# Magicard CUPS driver Testing
This is the testing section of the magicard cups driver project. It was originally created to allow for Test Driven Developmennt of the rp2mag modules, but could (and should!) be used to unit test other modules.

It uses the [Unity C testing framework](http://www.throwtheswitch.org/unity), which is light, unobtrusive and easy to use.

## Building
To build the tests, compile the test file against the modules it is testing, for example;

`gcc -DTEST -I ../src/ test_rp2_mag.c unity/src/unity.c ../src/rp2mag.c ../src/rp2mag_encode.c ../src/utils.c`

Note that the test must be compiled with `TEST` defined. This allow the test file to access the `static` function definitions, through some macro magic.

It is also recommended to chain your compilation with a valgrind run, so as to catch any memory errors early;

`gcc -DTEST -I ../src/ test_rp2_mag.c unity/src/unity.c ../src/rp2mag.c ../src/rp2mag_encode.c ../src/utils.c  && valgrind --leak-check=full ./a.out`

You'll get a warm fuzzy feeling when you see the line `All heap blocks were freed -- no leaks are possible`, I guarentee it.

The debug output from the module is supressed with the compile commands mentioned above, but they can easily be reinstated by adding `-g -DDEBUG` to the compile command.